// gwWindowBase.cpp: gwWindowBase NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////
#include "GWsystem.h"
#include "gwWindowBase.h"
#include ".\gwwindowbase.h"

LRESULT CALLBACK WndProc(HWND hwnd,UINT message,WPARAM wparam,LPARAM lparam);
static gwWindowBase *lpgw;

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////
gwWindowBase::gwWindowBase()
{
	hMutex = NULL;
	lpgw   = this;
	/* ϐݒ */
	szWindowClassName = "WindowClass";
}

gwWindowBase::~gwWindowBase()
{
	/* nh̉ */
	if(hMutex != NULL)
	{
		ReleaseMutex( hMutex );
	}
}

/********************************************************/
/*				dNh~`FbN					*/
/*	FȂ											*/
/*	߂lF0̎     > dNȂ					*/
/*			0ȊO̎ > dN( I )		*/
/********************************************************/
int gwWindowBase::gwCheckDubleStart()
{
	/*********************************** dNh~`FbN ***********************************/
	hMutex = CreateMutex( NULL, TRUE, "__GW__SYSTEM");		//݂̋NԂ擾
	if(GetLastError() == ERROR_ALREADY_EXISTS)
	{/* dNꍇ */
		MessageBox( NULL, "dNI", "eXg", MB_OK );
		HWND hWnd = FindWindow(NULL, PROGRAM_TITLE);			//eEChE{
		if( hWnd != NULL )
		{/* eEChEꍇ */
			MessageBox( NULL, "vOI", "eEChEI", MB_OK );
			SetForegroundWindow( hWnd );						//eEChEANeBuɐݒ
			ShowWindow(hWnd, SW_SHOWNORMAL);
		}
		return _GW_ERROR;		//vOI
	}
	return _GW_OK;
}

/********************************************************/
/*				windowsOS							*/
/*	FȂ											*/
/*	߂lF0̎     > Windows9Xn						*/
/*			0ȊO̎ > NTn(2000/XPȍ~)				*/
/********************************************************/
int gwWindowBase::gwCheckOSVersion()
{
	OSVERSIONINFOA osVerInfo;

	int ret = _GW_OK;

	/* OS̎擾 */	
	osVerInfo.dwOSVersionInfoSize = sizeof(osVerInfo);
	GetVersionExA(&osVerInfo);

	/* o[W̎擾 */
	switch(osVerInfo.dwPlatformId)
	{
		case VER_PLATFORM_WIN32_NT:			//Windows NTn(NT/2000/XP/vista/7)
			if(osVerInfo.dwMajorVersion <= 4)
			{
				MessageBox( hWnd, "Windows NT́AT|[gOłB", "OSo[W`FbN", MB_OK );
				ret = _GW_ERROR;			//Windows NT́AT|[gOłB
			}
			else{ //2000/XP/vista/7
				//́AT|[g
				if(osVerInfo.dwMajorVersion == 5)
				{//2000 or XP
					ret = _GW_OK;			//T|[gΏۂłB
					switch(osVerInfo.dwMinorVersion)
					{
						case 0: MessageBox( NULL, "Windows 2000łB",			"OSo[W`FbN", MB_OK ); break; //windows 2000
						case 1: MessageBox( NULL, "Windows XPłB",			"OSo[W`FbN", MB_OK ); break; //windows XP
						case 2: MessageBox( NULL, "Windows 2003 ServerłB",  "OSo[W`FbN", MB_OK ); break; //windows XP
					}
				}
				else if(osVerInfo.dwMajorVersion == 6)
				{
					switch(osVerInfo.dwMinorVersion)
					{
						case 0: MessageBox( NULL, "Windows VistałB",		"OSo[W`FbN", MB_OK ); break; //windows XP
						case 1: MessageBox( NULL, "Windows 7łB",			"OSo[W`FbN", MB_OK ); break; //windows 7
						default:
								MessageBox( NULL, "Windows 7ȍ~OSłB",	"OSo[W`FbN", MB_OK ); //windows 7ȍ~OS
								break; 
					}
				}
				else{
					MessageBox( NULL, "Windows 7ȍ~OSłB",	"OSo[W`FbN", MB_OK ); //windows 7ȍ~OS
				}
			}
			break;

		case VER_PLATFORM_WIN32_WINDOWS:	//Windows 9Xn
		default:							//(windows3.1AWindows CȄꍇɗ܂B)
			ret = _GW_ERROR;
			break;
	}
	return ret;
}

/********************************************************/
/*				dNh~`FbN					*/
/*	FȂ											*/
/*	߂lF0̎     > I						*/
/*			0ȊO̎ > ُI						*/
/********************************************************/
int gwWindowBase::gwCreateWindow( HINSTANCE hInstance, 
								  HINSTANCE hPrevInstance, 
								  LPSTR     pCmdLine, 
								  int       nCmdShow )
{

	/**********************NX̐ݒ*******************************/
	WNDCLASSEX wcex;

	wcex.cbSize         = sizeof(WNDCLASSEX); 
	wcex.style		    = CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon		    = LoadIcon(NULL,   IDI_APPLICATION);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= NULL;
	wcex.lpszClassName	= szWindowClassName;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_APPLICATION);

	if( RegisterClassEx( &wcex ) == 0) return _GW_ERROR;		//EChE̓o^Ɏs

	/* EChE̍쐬 */
    hWnd=CreateWindow(  szWindowClassName,  
                        WINDOW_TITLE,
                        WS_OVERLAPPEDWINDOW,
                        CW_USEDEFAULT,
                        CW_USEDEFAULT,
                        SCREEN_W,
                        SCREEN_H,
                        NULL,
                        NULL,
                        hInstance,
                        NULL);

	if(hWnd == NULL)	return _GW_ERROR;		//EChEnh̎擾Ɏs
    ShowWindow(hWnd,nCmdShow);				    /*  EChE̕\        */
    UpdateWindow(hWnd);						    /*  EChE̍ŏ̍XV  */

	return _GW_OK;
}

/********************************************************/
/*				CDNh~`FbN						*/
/*	FȂ											*/
/*	߂lF0̎     > CD/DVDNłȂ				*/
/*			0ȊO̎ > CD/DVDN						*/
/********************************************************/
int gwWindowBase::gwCheckCDStart(void)
{
	char curDir[] = "D:\\";	//Ώۂ̃hCupXB

	switch(GetDriveType( &curDir[0] ))
	{
		case DRIVE_UNKNOWN:     MessageBox( NULL, "hCu̎ʂsłB",                           "hCu`FbN", MB_OK ); break;
		case DRIVE_NO_ROOT_DIR: MessageBox( NULL, "w̃fBNg܂łB",	          "hCu`FbN", MB_OK ); break;
		case DRIVE_REMOVABLE:   MessageBox( NULL, "̃fBXŃAhCuo܂B",	          "hCu`FbN", MB_OK ); break;
		case DRIVE_FIXED:       MessageBox( NULL, "̃fBXŃAhCuo܂B",         "hCu`FbN", MB_OK ); break;
		case DRIVE_REMOTE:      MessageBox( NULL, "̃hCúA[g(lbg[N)hCułB", "hCu`FbN", MB_OK ); break;
		case DRIVE_CDROM:       MessageBox( NULL, "̃hCúACDEDVDhCułB",				  "hCu`FbN", MB_OK ); break;
		case DRIVE_RAMDISK:     MessageBox( NULL, "̃hCúARAMfBXNłB",					  "hCu`FbN", MB_OK ); break;
		default:
			MessageBox(NULL, "hCu̔ʏɎs܂B",	"hCu`FbN", MB_OK ); break;
			break;
	}
	return _GW_OK;
}


/****************************************************************************/
/*					Windows̃bZ[W[v								*/
/****************************************************************************/
LONG gwWindowBase::gwMessageLoop()
{
	MSG             msg;    /*  bZ[WL[擾bZ[W  */

    while(GetMessage(&msg,NULL,0,0))    /*  bZ[W[v  */
    {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
    }
	return  msg.wParam;
}

/****************************************************************************/
/*					Windows̃bZ[W@\								*/
/****************************************************************************/
LRESULT CALLBACK WndProc(HWND hwnd,UINT message,WPARAM wparam,LPARAM lparam)
{
    switch(message)
    {
        case WM_DESTROY:
            PostQuitMessage(0);
            return  0;

		case WM_KEYDOWN:
			if( (int)wparam == VK_ESCAPE )	PostMessage( lpgw->hWnd, WM_CLOSE, 0, 0);	//IbZ[W|Xg
			break;
    }
    return  DefWindowProc(hwnd,message,wparam,lparam);
}
